// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  TU Dresden                                                            ==
// ==                                                                        ==
// ==  Institut fr Wissenschaftliches Rechnen                               ==
// ==  Zellescher Weg 12-14                                                  ==
// ==  01069 Dresden                                                         ==
// ==  germany                                                               ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  https://gforge.zih.tu-dresden.de/projects/amdis/                      ==
// ==                                                                        ==
// ============================================================================

/** \file ParallelProblemStatBase.h */

#ifndef AMDIS_PARALLEL_PROBLEM_STAT_BASE_H
#define AMDIS_PARALLEL_PROBLEM_STAT_BASE_H

#include "ProblemVec.h"

namespace AMDiS {

  class ParallelProblemStatBase : public ProblemVec
  {
  public:
    ParallelProblemStatBase(std::string nameStr,
			    ProblemIterationInterface *problemIteration = NULL)
      : ProblemVec(nameStr, problemIteration),
	meshDistributor(NULL)
    {}


    void buildAfterCoarsen(AdaptInfo *adaptInfo, Flag flag,
			   bool assembleMatrix,
			   bool assembleVector)
    {
      meshDistributor->checkMeshChange();
      ProblemVec::buildAfterCoarsen(adaptInfo, flag, assembleMatrix, assembleVector);
    }


    void addToMeshDistributor(MeshDistributor& m)
    {
      meshDistributor = &m;
      m.addProblemStat(this);
    }

  protected:
    MeshDistributor *meshDistributor;     
  };
}

#endif
