#include "Mesh.h"
#include "Parameters.h"
#include "ProblemScal.h"

#include <sstream>

using namespace AMDiS;
void testMesh(int dim) {
	std::stringstream ss;
	ss<< dim;
	Parameters::addGlobalParameter(0, "dimension of world", ss.str());
	Global::init();
	Mesh mesh("testMesh", dim);
	DimVec< int > ln_dof(dim, DEFAULT_VALUE, 0);
	ln_dof[VERTEX]=1;
	mesh.createDOFAdmin("vertex_dofs", ln_dof);
	mesh.initialize();
}

int main(int argc, char** argv) {
  //cannot use Parameters::addGlobalParameter(...) because of some string errors
  Parameters::addGlobalParameter(0,"testMesh1->macro file name","macro/macro.stand.1d");
  Parameters::addGlobalParameter(0,"testMesh2->macro file name","macro/macro.stand.2d");
  Parameters::addGlobalParameter(0,"testMesh3->macro file name","macro/macro.stand.3d");

  testMesh(1);
  testMesh(2);
  testMesh(3);

  return 0;
}

